<template>
  <div class="sw-gs-guide-login" @keyup.enter="invokeLogin">
    <div class="form sw-gs-guide-login__form">
      <div>
        <SwAlert v-if="hasErrors" :message="$t('Invalid username and/or password.')" type="danger"/>
        <SwInput v-model="username"
                 name="loginUsername"
                 :label="$t('Your administration username')"
                 class="sw-form__input"
                 type="username"
                 :valid="!$v.username.$error"
                 :disabled="isLoading"
                 :error-message="$t('Username is required')"
                 @blur="$v.username.$touch()"/>
        <SwInput v-model="password"
                 name="loginPassword"
                 :label="$t('Password')"
                 type="password"
                 class="sw-form__input"
                 :valid="!$v.password.$error"
                 :disabled="isLoading"
                 :error-message="$t('Password is required')"
                 @blur="$v.password.$touch()"/>
        <SfCheckbox 
                 v-if="videoAndAudioSetting"
                 v-model="acceptance"
                 class="sw-form__input"
                 name="checkbox"
        >
          <template #label>
            <span class="sf-checkbox__label" v-html="$t('I accept the privacy policy of daily.co')" />
          </template>
        </SfCheckbox>
        <!-- here -->
        <SwButton type="button" class="sf-button--full-width sw-form__button" :disabled="isLoading || $v.$invalid" @click="invokeLogin">
          {{ $t("Log in") }}
        </SwButton>
        <div class="sw-register-button">
          <a @click="openRegisterModal">{{$t(`Register if you don't have account`)}}</a>
        </div>
        <SwRegisterModal
          :is-open="isRegisterModalOpen"
          @close="switchLoginModalState(false)"
        />
      </div>
    </div>
  </div>
</template>

<script>
  import SwAlert from "@/components/atoms/SwAlert.vue"
  import useVuelidate from "@vuelidate/core"
  import { required } from "@vuelidate/validators"
  import { useAdminApiInstance } from "../logic/composables/useAdminApiInstance"
  import { useAppointment } from "../logic/composables/useAppointment";
  import SwButton from "@/components/atoms/SwButton.vue"
  import SwInput from "@/components/atoms/SwInput.vue"
  import { ref, reactive, toRefs, computed } from "@vue/composition-api"
  import { SfCheckbox } from "@storefront-ui/vue"
  import SwRegisterModal from './modals/SwRegisterModal.vue';
  import { useUIState } from "@shopware-pwa/composables"


  export default {
    name: "SwGsGuideLoginForm",
    components: {
      SwButton,
      SfCheckbox,
      SwInput,
      SwRegisterModal,
      SwAlert,
    },
    setup() {
      const { authenticate, errors } = useAdminApiInstance();
      const { videoAndAudioSetting } = useAppointment();
      const { isOpen: isRegisterModalOpen, switchState: switchRegisterModalState } =
        useUIState({ stateName: "REGISTER_MODAL_STATE" })
      const isLoading = ref(false);
      const state = reactive({
        username: '',
        password: '',
        acceptance: false
      })
      const rules = {
        username: {
          required,
        },
        password: {
          required,
        },
        acceptance: {
          checked: value => {
            if (!videoAndAudioSetting.value) {
              return true;
            } else {
              return value === true
            }
          }
        }
      }
      const $v = useVuelidate(rules, state);

      async function invokeLogin() {
        $v.value.$touch()

        if ($v.value.$invalid) {
          return
        }

        await authenticate(state.username, state.password);
      }

      function openRegisterModal() {
        switchRegisterModalState(true);
      }

      return {
        authenticate,
        isLoading,
        videoAndAudioSetting,
        isRegisterModalOpen,
        openRegisterModal,
        hasErrors: computed(() => errors.value?.length > 0),
        $v,
        ...toRefs(state),
        invokeLogin
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "@/assets/scss/forms";

  .sw-gs-guide-login {

    .sw-gs-guide-login__form {
      max-width: 450px;
      margin: 0 auto;
      padding-top: 30px;
    }

    .sf-alert {
      margin-bottom: var(--spacer-base);
    }
  }

  .sw-register-button {
    margin-top: 20px;
    display: flex;
    justify-content: center;
    text-decoration: underline;
    a {
      cursor: pointer;
    }
  }
</style>
